
***********************************************************************************************************************************************************************************************
*  msg() -  messagebox().     (   )  0   .        								     					  *
*                             																																								  *		
* : [n__] = msg([c],[c__] | [n_],[c_],[c_],[c__],[c__]) *
*																																															  *						
* :   lf@newmail.ru       Jek Zevs  jek_zevs@aport2000.ru																		   		      *		
***********************************************************************************************************************************************************************************************
FUNCTION msg
LPARAMETERS lcpMessageText, lcpCommandString, lcpImageString, lcpFormString, lcpEditFontString, lcpCommandFontString

	*
	*   ( ):																														   
	*																																	   		
	*  lcpMessageText -  ,    chr(13)  chr(9)																									   		
    *
	*  lcpCommandString -    . 
    *	                  : "[c1 [, c2[, c3]]] | [n_]"
    *                     n_ -         messagebox()
    *                      1  2   '\<',      .
    *                            .
    *                           . (.  lnCommandFocus     ) 
    *
	*  lcpImageString -    . 
	*                   : "[c__ [, n, n]] | [n_]"
	*                   c__ -       ,   .
    *                    : "info", "stop", "quest", "alert", "alertred" ( 32  32   ).
    *                   n, n -    
    *                         0,1,2,3,4 - .
    *
    *                   	           
	*  lcpFormString -    . 
	*                  : "[c_  [, n__ [, n_, n_]]]" 
	*                  c_ -      ,          .
    *                  n__ -  ,     .
    *                      0,    .
    *                  n_, n_ -       -  .
    *
    *
	*  lcpEditFontString -     . 
	*                      : "[c_ [, n [, c [, n ]]]]"
	*                      c_ -  ,   .
	*                      n -  .
	*                      c -  : "B", "I", "BI" - ,    .
	*                      n -    
	*
	*  lcpCommandFontString -       .
	*                         : "[c_ [, n [, c [, n ]]]]"
    *																																	   		
    *
    *    ,     ,    .
    *         , ,    ,
    *         Init()  
    *
    
  *******************************
  *   
  
  lcMessageText = ""
  lnMaxEditWidthPerScreen  = 0.5 &&     ,    lnMaxEditWidthPerScreen*_SCREEN.Width,
                                 &&      

  lcEditFontName = "MS Sans Serif"
  lnEditFontSize = 8
  lcEditFontStyle = ""
  lnEditFontColor = 0
  lnEditTop = 10

  lcCommand1Caption = "OK"
  lcCommand2Caption = ""
  lcCommand3Caption = ""
  lcCommandFontName = "MS Sans Serif"
  lnCommandFontSize = 8
  lcCommandFontStyle = ""
  lnCommandFontColor = 0 
  lnCommandCount  = 1
  lnCommandFocus = 1 && (0 -      , 1 -  )
  lnAllCommandWidthPerFormWidth = 0.6 &&       lnFormWidth*lnAllCommandWidthPerFormWidth,
                                      &&    ""

  lcImageFileName = ""
  lnImageTop = 10
  lnImageWidth = 0
  lnImageHeight = 0

  lcFormCaption = "Microsoft Visual FoxPro"
  lnFormLeft = 0
  lnFormTop = 0
  lnTimeInterval = 0

  *    
  *******************************

 
  *  
  if TYPE("lcpMessageText") == "C"
	    lcMessageText = lcpMessageText
  endif


  *   ,     
  if TYPE("lcpCommandString") == "N" .and. int(lcpCommandString) > 0 
      lnpCommandString = int(lcpCommandString)     

      lnpFocus = int(lnpCommandString/256)
      lnpIcon = int((lnpCommandString - lnpFocus*256)/16)
      lnpCommand = lnpCommandString - lnpFocus * 256  - lnpIcon * 16

    do case

       case lnpCommand = 0

		  lcCommand1Caption = "OK"
		  lcCommand2Caption = ""
		  lcCommand3Caption = ""
		  lnCommandCount  = 1

       case lnpCommand = 1

		  lcCommand1Caption = "OK"
		  lcCommand2Caption = "Cancel"
		  lcCommand3Caption = ""
		  lnCommandCount  = 2

       case lnpCommand = 2

          * Abort, Retry, Ignore (     : " ,  ,  ") 
		  lcCommand1Caption = ""
		  lcCommand2Caption = ""
		  lcCommand3Caption = ""
		  lnCommandCount  = 3
       
       case lnpCommand = 3

          * Yes, No, Cancel 
		  lcCommand1Caption = ""
		  lcCommand2Caption = ""
		  lcCommand3Caption = " "
		  lnCommandCount  = 3

       case lnpCommand = 4

          * Yes, No
		  lcCommand1Caption = ""
		  lcCommand2Caption = ""
		  lcCommand3Caption = ""
		  lnCommandCount  = 2

       case lnpCommand = 5

          * Retry, Cancel
		  lcCommand1Caption = "Retry"
		  lcCommand2Caption = "Cancel"
		  lcCommand3Caption = ""
		  lnCommandCount  = 2

     endcase  
     
     do case

        case lnpIcon = 1
            lcpImageString="stop"

        case lnpIcon = 2
            lcpImageString="quest"

        case lnpIcon = 3
            lcpImageString="alert"

        case lnpIcon = 4
            lcpImageString="info"
            
     endcase
            

     do case

        case lnpFocus = 0
            lnCommandFocus = 1

        case lnpFocus = 1
            lnCommandFocus = 2

        case lnpFocus = 2
            lnCommandFocus = 3
            
     endcase
            

  endif
  *    ,    


  *   ,    
  if TYPE("lcpCommandString") == "C" .and. len(alltrim(lcpCommandString)) > 0 
     lnCommaPlace1 = at(',',lcpCommandString,1)
     lnCommaPlace2 = at(',',lcpCommandString,2)
     if lnCommaPlace1 > 0
         lcCommand1Caption = alltrim(left(lcpCommandString, lnCommaPlace1 - 1))
         if left(lcCommand1Caption,2) == "\<"
             lnCommandFocus = 1
             lcCommand1Caption = substr(lcCommand1Caption,3)
         endif
         if lnCommaPlace2 > 0
             lcCommand2Caption = alltrim(substr(lcpCommandString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1))
	         if left(lcCommand2Caption,2) == "\<"
    	         lnCommandFocus = 2
        	     lcCommand2Caption = substr(lcCommand2Caption,3)
	         endif

             lcCommand3Caption = alltrim(substr(lcpCommandString,lnCommaPlace2 + 1))
	         if left(lcCommand3Caption,2) == "\<"
    	         lnCommandFocus = 3
        	     lcCommand3Caption = substr(lcCommand3Caption,3)
	         endif

             lnCommandCount = 3
         else
             lcCommand2Caption = alltrim(substr(lcpCommandString,lnCommaPlace1 + 1))
	         if left(lcCommand2Caption,2) == "\<"
    	         lnCommandFocus = 2
        	     lcCommand2Caption = substr(lcCommand2Caption,3)
	         endif

             lnCommandCount = 2
         endif
     else
         lcCommand1Caption = alltrim(lcpCommandString)
         if left(lcCommand1Caption,2) == "\<"
    	         lnCommandFocus = 1
        	     lcCommand1Caption = substr(lcCommand1Caption,3)
         endif

         lnCommandCount = 1
     endif     
  endif
  *      

  *   

   *    .  
   if TYPE("lcpImageString") == "N"
      do case
         case lcpImageString = 0
            lcpImageString = "info"
         case lcpImageString = 1
            lcpImageString = "stop"
         case lcpImageString = 2
            lcpImageString = "quest"
         case lcpImageString = 3
            lcpImageString = "alert"
         case lcpImageString = 4
            lcpImageString = "alertred"
         otherwise
            lcpImageString = ''
      endcase
   endif

   *    
  if TYPE("lcpImageString") == "C" .and. len(alltrim(lcpImageString)) > 0 
     if  file(alltrim(lcpImageString)+".bmp")
         lcImageFileName = alltrim(lcpImageString)+".bmp"
         lnImageWidth = 32
         lnImageHeight = 32
     else
	     lnCommaPlace1 = at(',',lcpImageString,1)
    	 lnCommaPlace2 = at(',',lcpImageString,2)
	     if lnCommaPlace1 > 0 .and. lnCommaPlace2 > 0 .and. file(alltrim(left(lcpImageString, lnCommaPlace1 - 1))+".bmp") .and. int(val(substr(lcpImageString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1))) > 0 .and. int(val(substr(lcpImageString,lnCommaPlace2 + 1))) > 0
    	     lcImageFileName = alltrim(left(lcpImageString, lnCommaPlace1 - 1))+".bmp"
             lnImageWidth  = int(val(substr(lcpImageString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1)))
	         lnImageHeight = int(val(substr(lcpImageString,lnCommaPlace2 + 1)))
	     endif     
     endif
  endif             
  *    


  *    
  if TYPE("lcpFormString") == "C"  
	     lnCommaPlace1 = at(',',lcpFormString,1)
   		 lnCommaPlace2 = at(',',lcpFormString,2)
   		 lnCommaPlace3 = at(',',lcpFormString,3)
         if lnCommaPlace1 > 0 
  		     if lnCommaPlace2 > 0 .and. lnCommaPlace3 > 0 
    			     lcFormCaption = alltrim(left(lcpFormString, lnCommaPlace1 - 1))
                     *   ,        
            		 lnTimeInterval  = MAX(int(val(substr(lcpFormString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1))),0)
            		 lnFormLeft  = MAX(int(val(substr(lcpFormString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1))),0)
			         lnFormTop = MAX(int(val(substr(lcpFormString,lnCommaPlace3 + 1))),0)
             else
   			     lcFormCaption = alltrim(left(lcpFormString, lnCommaPlace1 - 1))
           		 lnTimeInterval  = MAX(int(val(substr(lcpFormString,lnCommaPlace1 + 1))),0)
             endif
    	 else
       	     lcFormCaption = alltrim(lcpFormString)
    	 endif
  endif             

  if lnTimeInterval > 0 .AND. len(alltrim(lcFormCaption)) = 0 
      lcFormCaption = ""
  endif

  *     


  *      
  if TYPE("lcpEditFontString") == "C" .and. len(alltrim(lcpEditFontString)) > 0 

	     lnCommaPlace1 = at(',',lcpEditFontString,1)
    	 lnCommaPlace2 = at(',',lcpEditFontString,2)
    	 lnCommaPlace3 = at(',',lcpEditFontString,3)

	     if lnCommaPlace1 > 0
            if len(alltrim(left(lcpEditFontString, lnCommaPlace1 - 1))) > 0
   	           lcEditFontName = alltrim(left(lcpEditFontString, lnCommaPlace1 - 1))
            endif 
	        if lnCommaPlace2 > 0
               if int(val(substr(lcpEditFontString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1))) > 0
	    	      lnEditFontSize = int(val(substr(lcpEditFontString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1)))
               endif
               if lnCommaPlace3 > 0
	              if alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1))) = "B" .or. alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1))) = "I" .or. alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1))) = "BI"  
		    	     lcEditFontStyle = alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1)))
        	      endif
	              if int(val(substr(lcpEditFontString,lnCommaPlace3 + 1))) > 0 
   		    	     lnEditFontColor = int(val(substr(lcpEditFontString,lnCommaPlace3 + 1)))
                  endif
               else
	              if alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1))) == "B" .or. alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1))) == "I" .or. alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1))) == "BI"
		    	     lcEditFontStyle = alltrim(UPPER(substr(lcpEditFontString,lnCommaPlace2 + 1)))
                  endif
               endif
	        else
               if int(val(substr(lcpEditFontString,lnCommaPlace1 + 1))) > 0
	    	      lnEditFontSize = int(val(substr(lcpEditFontString,lnCommaPlace1 + 1)))
               endif
	        endif
    	 else
        	 lcEditFontName = alltrim(lcpEditFontString)
    	 endif     
  endif             
  *       

  *        
  if TYPE("lcpCommandFontString") == "C" .and. len(alltrim(lcpCommandFontString)) > 0 

	     lnCommaPlace1 = at(',',lcpCommandFontString,1)
    	 lnCommaPlace2 = at(',',lcpCommandFontString,2)
    	 lnCommaPlace3 = at(',',lcpCommandFontString,3)

	     if lnCommaPlace1 > 0
            if len(alltrim(left(lcpCommandFontString, lnCommaPlace1 - 1))) > 0
   	           lcCommandFontName = alltrim(left(lcpCommandFontString, lnCommaPlace1 - 1))
            endif 
	        if lnCommaPlace2 > 0
               if int(val(substr(lcpCommandFontString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1))) > 0
	    	      lnCommandFontSize = int(val(substr(lcpCommandFontString,lnCommaPlace1 + 1, lnCommaPlace2 -  lnCommaPlace1 - 1)))
               endif
               if lnCommaPlace3 > 0
	              if alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1))) = "B" .or. alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1))) = "I" .or. alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1))) = "BI"  
		    	     lcCommandFontStyle = alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1, lnCommaPlace3 -  lnCommaPlace2 - 1)))
        	      endif
	              if int(val(substr(lcpCommandFontString,lnCommaPlace3 + 1))) > 0 
   		    	     lnCommandFontColor = int(val(substr(lcpCommandFontString,lnCommaPlace3 + 1)))
                  endif
               else
	              if alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1))) == "B" .or. alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1))) == "I" .or. alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1))) == "BI"
		    	     lcCommandFontStyle = alltrim(UPPER(substr(lcpCommandFontString,lnCommaPlace2 + 1)))
                  endif
               endif
	        else
               if int(val(substr(lcpCommandFontString,lnCommaPlace1 + 1))) > 0
	    	      lnCommandFontSize = int(val(substr(lcpCommandFontString,lnCommaPlace1 + 1)))
               endif
	        endif
    	 else
        	 lcCommandFontName = alltrim(lcpCommandFontString)
    	 endif     
  endif             
  *         


  *           
  *    ,  lnMaxEditWidthPerScreen*_SCREEN.Width,
  *     
  
  lnLineCount = 1  && -  
  lnSpacePos = 0 &&       
  lnMaxWidth = 0 &&  
  lcNowChar = '' &&  
  lcNowString = '' &&  
  lcOutMessageText = '' &&   
  lnCharPosInNowString = 0 &&       
  
  for lnPos = 1 to len(lcMessageText)
   
   lcNowChar = substr(lcMessageText,lnPos,1)
   lnCharPosInNowString = lnCharPosInNowString + 1
   lnNowStringWidth = StringWidth(lcNowString+lcNowChar,lcEditFontName,lnEditFontSize,lcEditFontStyle)
 
   *   
   do case
  
	   *    chr(13) -   
	   case (lcNowChar == chr(13))
   
       	 lnMaxWidth = MAX(lnMaxWidth,lnNowStringWidth)
	     lnLineCount = lnLineCount + 1
	     lcOutMessageText = lcOutMessageText + lcNowString + chr(13)
	     lcNowString = ''
         lnSpacePos = 0
         lnCharPosInNowString = 0

	   *     
	   case (lcNowChar == " ")

          *       -   
          if (lnNowStringWidth > _SCREEN.Width*lnMaxEditWidthPerScreen) 
 
	       	 lnMaxWidth = MAX(lnMaxWidth,lnNowStringWidth)
		     lnLineCount = lnLineCount + 1
	    	 lcOutMessageText = lcOutMessageText + lcNowString + chr(13)
		     lcNowString = ''
    	     lnSpacePos = 0
             lnCharPosInNowString = 0

          else
          *     -       

              lnSpacePos =  lnCharPosInNowString 
              lcNowString = lcNowString + ' '

		  endif        
          *     

	   *  
	   otherwise 
		   *      
		   if (lnNowStringWidth > _SCREEN.Width*lnMaxEditWidthPerScreen .AND. lnSpacePos > 0)

  		         lnLineCount = lnLineCount + 1
                 lnNowStringWidth = StringWidth(left(lcNowString, lnSpacePos-1)+chr(13),lcEditFontName,lnEditFontSize,lcEditFontStyle)
	        	 lnMaxWidth = MAX(lnMaxWidth,lnNowStringWidth)
	    	     lcOutMessageText = lcOutMessageText + left(lcNowString, lnSpacePos-1)+chr(13)
    	         lcNowString = substr(lcNowString, lnSpacePos + 1) + lcNowChar
        	     lnSpacePos = 0
                 lnCharPosInNowString = len(lcNowString)

           else
           *   

               lcNowString = lcNowString + lcNowChar  

           endif

    endcase
    *    
      
  endfor

  lnMaxWidth = MAX(lnMaxWidth,lnNowStringWidth)

 
  *      
  lcMessageText = lcOutMessageText + lcNowString 
  
  *
  *     
  *

  *   
  lnEditWidth = lnMaxWidth + 8

  *   -         - 
  lnEditHeight = StringHeight(lcEditFontName,lnEditFontSize,lcEditFontStyle,.T.)*lnLineCount + 3


  *   -   (1.8)  
  *     ,     
  lnCommandHeight = StringHeight(lcCommandFontName,lnCommandFontSize,lcCommandFontStyle,.F.)*1.8
  
  *   (     )
  *     ,     
  lnCommand1Width = StringWidth(lcCommand1Caption,lcCommandFontName,lnCommandFontSize,lcCommandFontStyle)
  if lnCommand1Width > 0
	  lnCommand1Width = MAX(lnCommand1Width + 20, lnCommand1Width + lnCommandHeight * 1) 
  endif
  lnCommand2Width = StringWidth(lcCommand2Caption,lcCommandFontName,lnCommandFontSize,lcCommandFontStyle)
  if lnCommand2Width > 0
	  lnCommand2Width = MAX(lnCommand2Width + 20, lnCommand2Width + lnCommandHeight * 1) 
  endif
  lnCommand3Width = StringWidth(lcCommand3Caption,lcCommandFontName,lnCommandFontSize,lcCommandFontStyle) 
  if lnCommand3Width > 0
	  lnCommand3Width = MAX(lnCommand3Width + 20, lnCommand3Width + lnCommandHeight * 1) 
  endif

  *    
  if lnCommand1Width > 0
	  lnCommand1Width = MAX(lnCommand1Width, lnCommand2Width, lnCommand3Width) 
  endif
  if lnCommand2Width > 0
	  lnCommand2Width = MAX(lnCommand1Width, lnCommand2Width, lnCommand3Width) 
  endif
  if lnCommand3Width > 0
	  lnCommand3Width = MAX(lnCommand1Width, lnCommand2Width, lnCommand3Width) 
  endif
  
  
  *   
  if lnTimeInterval > 0
     *  ,    4  (  3 )   
	  lnFormCaptionWidth = StringWidth(lcFormCaption + " 999","MS Sans Serif",10,"")
  else
	  lnFormCaptionWidth = StringWidth(lcFormCaption,"MS Sans Serif",10,"")
  endif 

  *  .    : 
  * 1)   +   + 2   10   + 10    ,   ,
  * 2)    + -   , ,   ,   20   ,
  * 3)   
  lnFormWidth = MAX(lnEditWidth + 20 + lnImageWidth + IIF(lnImageWidth > 0, 10,0), lnCommand1Width + lnCommand2Width + lnCommand3Width + lnCommandCount*MAX(20,lnCommandHeight), lnFormCaptionWidth) 



  *           - 2  
  lnFormHeight = MIN(lnImageTop,lnEditTop)+MAX(lnImageHeight,lnEditHeight)+lnCommandHeight*2 

  *    ,     
  if  lnFormLeft = 0
	lnFormLeft = (_SCREEN.Width - lnFormWidth)/2
  endif

  *    ,      
  * ( -12  ,   -  )
  if  lnFormTop = 0
	lnFormTop = (_SCREEN.Height - lnFormHeight)/2 - 12
  endif


  *       lnFormWidth*lnAllCommandWidthPerFormWidth 
  *     
  if lnCommand1Width + lnCommand2Width + lnCommand3Width < lnFormWidth*lnAllCommandWidthPerFormWidth 
      lnAddWidth = int((lnFormWidth*lnAllCommandWidthPerFormWidth - (lnCommand1Width + lnCommand2Width + lnCommand3Width))/lnCommandCount) 
      if lnCommand1Width > 0
        lnCommand1Width = lnCommand1Width  + lnAddWidth
      endif
      if lnCommand2Width > 0
        lnCommand2Width = lnCommand2Width  + lnAddWidth
      endif
      if lnCommand3Width > 0
        lnCommand3Width = lnCommand3Width  + lnAddWidth
      endif
  endif
  *   ,    ,  lnFormWidth*lnAllCommandWidthPerFormWidth

  *    .  ""      -   
  lnEditLeft = (lnFormWidth - lnEditWidth + lnImageWidth + IIF(lnImageWidth > 0,10,0))/2 
  lnImageLeft = (lnEditLeft - lnImageWidth)/2


  *       -     
  *  -     
  if lnImageHeight < lnEditHeight
       lnImageTop = lnEditTop  + (lnEditHeight - lnImageHeight)/3 
  else
       lnEditTop = lnImageTop  + (lnImageHeight - lnEditHeight)/2
  endif
  
  *    
  *        0.6   
  * (      ,  - 0.4   )
  lnCommandTop = MIN(lnImageTop,lnEditTop) + MAX(lnImageHeight,lnEditHeight) + lnCommandHeight*0.6


  *     
  do case
    case lnCommandCount = 1
         
	  lnCommand1Left = 0
	  lnCommand2Left = 0
	  lnCommand3Left = lnFormWidth/2 - lnCommand1Width/2

    case lnCommandCount = 2
        
      lnDistance =  INT((lnFormWidth - lnCommand2Width - lnCommand1Width)/3.)
      
	  lnCommand1Left = 0 
	  lnCommand2Left = lnDistance 
	  lnCommand3Left = 2*lnDistance +  lnCommand1Width 

    case lnCommandCount = 3
         
      lnDistance =  INT((lnFormWidth - lnCommand1Width - lnCommand2Width - lnCommand3Width)/4.)
      
	  lnCommand1Left = lnDistance 
	  lnCommand2Left = 2*lnDistance +  lnCommand1Width 
	  lnCommand3Left = 3*lnDistance +  lnCommand1Width + lnCommand2Width

  endcase  
  *      

  lnReturnId = 0

  
  do form formmsg with lcMessageText, lnEditWidth, lnEditHeight, lnEditLeft, lnEditTop, ;
   	                   lcEditFontName, lnEditFontSize, lcEditFontStyle, lnEditFontColor, ;
       	               lnCommandCount, lcCommand1Caption, lcCommand2Caption, lcCommand3Caption, ;
           	           lnCommandTop, lnCommandHeight, ;
               	       lnCommand1Left, lnCommand2Left, lnCommand3Left, ;
                   	   lnCommand1Width, lnCommand2Width, lnCommand3Width, ;
                       lcCommandFontName, lnCommandFontSize, lcCommandFontStyle, lnCommandFontColor, ;
   	                   lcImageFileName,   lnImageHeight, lnImageWidth, lnImageLeft, lnImageTop, ;
       	               lcFormCaption, lnFormWidth, lnFormHeight, lnFormLeft, lnFormTop, lnCommandFocus, lnTimeInterval  ; 
           	       to  lnReturnId

	*
	*  :																														   
	*																																	   		
	*  lcMessageText -  ,																									   		
	*  lnEditWidth, lnEditHeight, lnEditLeft, lnEditTop - , ,      , 						   		
	*  lcEditFontName, lnEditFontSize, lcEditFontStyle, lnEditFontColor - , , ,   ,					   		
	*  lnCommandCount, lcCommand1Caption, lcCommand2Caption, lcCommand3Caption - -    ,							   		
	*  lnCommandTop, lnCommandHeight -     ,																	   			
	*  lnCommand1Left, lnCommand2Left, lnCommand3Left -   ,															   		
	*  lnCommand1Width, lnCommand2Width, lnCommand3Width  -  , 																   		
	*  lcCommandFontName, lnCommandFontSize, lcCommandFontStyle, lnCommandFontColor  - , , ,   , 			   			
	*  lcImageFileName,   lnImageHeight, lnImageWidth, lnImageLeft, lnImageTop - , , ,     ,    		
	*  lcFormCaption, lnFormWidth, lnFormHeight, lnFormLeft, lnFormTop - , , ,     .		   	
    *  lnCommandFocus -    ( )
	*  lnTimeInterval - ,     																																	   		
    *

RETURN lnReturnId
***********************
*   msg() *
***********************



**************************************************************
*  StringWidth() -      *
**************************************************************
FUNCTION StringWidth
LPARAMETERS lcString, lcFontName, lnFontSize, lcFontStyle
* :     													
* lcString - ,													
* lcFontName, lnFontSize, lcFontStyle - , ,  	

RETURN TXTWIDTH(lcString, lcFontName, lnFontSize, lcFontStyle)*FONTMETRIC(6, lcFontName, lnFontSize, lcFontStyle)
******************************
*   StringWidth()*
******************************




****************************************************************
*  StringHeight() -      *
****************************************************************
FUNCTION StringHeight
LPARAMETERS lcFontName, lnFontSize, lcFontStyle, llFontInterLineSpace
* :     													
* lcFontName, lnFontSize, lcFontStyle - , ,  	
* llFontInterLineSpace -                 

RETURN IIF(llFontInterLineSpace, FONTMETRIC(4, lcFontName, lnFontSize, lcFontStyle),0) + FONTMETRIC(1, lcFontName, lnFontSize, lcFontStyle)
*******************************
*   StringHeight()*
*******************************
